function bin_hdr_info = g_get_bin_hdr_info
bin_hdr_info = cell(29,3);
bin_hdr_info(:,1) = [...
    {'Job identification number.'}; ...
    {'Line number.  For 3-D poststack data, this will typically contain the in-line number.'}; ...
    {'Reel number.'}; ...
    {'Number of data traces per ensemble.'}; ...
    {'Number of auxiliary traces per ensemble.'}; ...
    {'Sample interval in microseconds (s).'}; ...
    {'Sample interval in microseconds  (s) of original field recording.'}; ...
    {'Number of samples per data trace.'}; ...
    {'Number of samples per data trace for original field recording.'}; ...
    {'Data sample format code.  Mandatory for all data. 1=4-byte IBM float; 2=4-byte, two`s complement integer; 3=2-byte, two`s complement integer; 4=4-byte fixed-point with gain (obsolete); 5=4-byte IEEE float; 6,7=not used; 8=1-byte, two`s complement integer'}; ...
    {'CMP fold.'}; ...
    {'Trace sorting code. -1=Other (should be explained in user Extended Textual Header); 0=Unknown; 1=As recorded (no sort); 2=CDP; 3=Single fold continuous profile; 4=Horizontally stacked; 5=Common source; 6=Common receiver; 7=Common offset; 8=Common mid-point; 9=Common conversion point'}; ...
    {'Vertical sum code. 1=no sum; 2=two sum; ... N=M-1 sum (M=2 to 32,767)'}; ...
    {'Sweep frequency at start (Hz).'}; ...
    {'Sweep frequency at end (Hz).'}; ...
    {'Sweep length (ms).'}; ...
    {'Sweep type code. 1=linear; 2=parabolic; 3=exponential; 4=other'}; ...
    {'Trace number of sweep channel'}; ...
    {'Sweep trace taper length in milliseconds at start if tapered'}; ...
    {'Sweep trace taper length in milliseconds at end'}; ...
    {'Taper type. 1=linear; 2=cos^2; 3=other'}; ...
    {'Correlated data traces. 1=no; 2=yes'}; ...
    {'Binary gain recovered. 1=yes; 2=no'}; ...
    {'Amplitude recovery method. 1=none; 2=spherical divergence; 3=AGC; 4=other'}; ...
    {'Measurement system. 1=Meters; 2=Feet'}; ...
    {'Impulse signal polarity. 1=Increase in pressure or upward geophone case movement gives negative number on tape; 2=Increase in pressure or upward geophone case movement gives positive number on tape'}; ...
    {'Vibratory polarity code: Seismic signal lags pilot signal by: 1=337.5 to 22.5; 2=22.5 to 67.5; 3=67.5 to 112.5; 4=112.5 to 157.5; 5=157.5 to 202.5; 202.5 to 247.5; 7=247.5 to 292.5; 8=292.5 to 337.5'};...
    {'Fixed length trace flag. 0=trace length may vary and the actual length is stored in 115-116 bytes of trace heder; 1=all traces have the same length'};...
    {'Extended textual header. 0=there are no additional textual header; positive number indicates that there exactly that many Extended Textual Headers'}];

bin_hdr_info(:,2:3) = {...
    3201,   4; ...
    3205,   4; ...
    3209,   4; ...
    3213,   2; ...
    3215,   2; ...
    3217,   2; ...
    3219,   2; ...
    3221,   2; ...
    3223,   2; ...
    3225,   2; ...
    3227,   2; ...
    3229,   2; ...
    3231,   2; ...
    3233,   2; ...
    3235,   2; ...
    3237,   2; ...
    3239,   2; ...
    3241,   2; ...
    3243,   2; ...
    3245,   2; ...
    3247,   2; ...
    3249,   2; ...
    3251,   2; ...
    3253,   2; ...
    3255,   2; ...
    3257,   2; ...
    3259,   2; ...
    3503,   2; ...
    3505,   2};